$(document).ready(function() {
    var top_menu_height = $('.top-menu').length ? $('.top-menu').height() : 0;
    let target_div = "";
    if (target.length === 1 && target[0]) {
        target_div = $('#' + target[0]);
    } else if (target.length == 2) {
        target_div = $('#' + target[0]).find("[data-preflix='" + target[1] + "']");

        if (target_div.length) {
            // open accordion-content-item
            target_div.addClass('active');

            // open parent accordion (collapsibles-accordion-content)
            var parentAccordion = target_div.closest('.collapsibles-accordion-content');
            if (parentAccordion.length) {
                parentAccordion.addClass('active');
                parentAccordion.find('.collapsibles-accordion-content-panel.faq-panel').addClass('expanded');
            }

            var parentItem = target_div.closest('.collapsibles-accordion-item');
            if (parentItem.length) {
                parentItem.addClass('active');
            }
        }
    } else if (target.length >= 3) {
        let parent = $('#' + target[0]).find("[data-preflix='" + target[1] + "']");
        if (!parent.length) {
            console.error("Parent element not found for target[0] and target[1]");
            return;
        }

        target_div = $('#'+parent.attr("id")).find("li.collapsibles-accordion-content-item[data-preflix='" + target[2] + "']");

        if (target_div.length) {
            // open accordion-content-item
            target_div.addClass('active');

            // open parent accordion (collapsibles-accordion-content)
            var parentAccordion = target_div.closest('.collapsibles-accordion-content');
            if (parentAccordion.length) {
                parentAccordion.addClass('active');
                parentAccordion.find('.collapsibles-accordion-content-panel.faq-panel').addClass('expanded');
            }

            var parentItem = target_div.closest('.collapsibles-accordion-item');
            if (parentItem.length) {
                parentItem.addClass('active');
            }
        }
    }

    // Scroll to target_div
    if (target_div !== "undefined" && target_div.length) {
        setTimeout(function() {
            $('html, body').animate({
                scrollTop: target_div.offset().top - top_menu_height
            }, 500);
        }, 200);
    }

    $(".icon-share").click(async function(event) {
        event.preventDefault();

        let link = $(this).attr("href");

        try {
            await copy(link);
            alert("The link has been copied to the clipboard!");
            console.log("Link copied successfully!");
        } catch (e) {
            console.error(e);
        }
    });
})

function copy(text) {
    return new Promise((resolve, reject) => {
        if (typeof navigator !== "undefined" && typeof navigator.clipboard !== "undefined" && navigator.permissions !== "undefined") {
            const type = "text/plain";
            const blob = new Blob([text], {
                type
            });
            const data = [new ClipboardItem({
                [type]: blob
            })];
            navigator.permissions.query({
                name: "clipboard-write"
            }).then((permission) => {
                if (permission.state === "granted" || permission.state === "prompt") {
                    navigator.clipboard.write(data).then(resolve, reject).catch(reject);
                } else {
                    reject(new Error("Permission not granted!"));
                }
            });
        } else if (document.queryCommandSupported && document.queryCommandSupported("copy")) {
            var textarea = document.createElement("textarea");
            textarea.textContent = text;
            textarea.style.position = "fixed";
            textarea.style.width = '2em';
            textarea.style.height = '2em';
            textarea.style.padding = 0;
            textarea.style.border = 'none';
            textarea.style.outline = 'none';
            textarea.style.boxShadow = 'none';
            textarea.style.background = 'transparent';
            document.body.appendChild(textarea);
            textarea.focus();
            textarea.select();
            try {
                document.execCommand("copy");
                document.body.removeChild(textarea);
                resolve();
            } catch (e) {
                document.body.removeChild(textarea);
                reject(e);
            }
        } else {
            reject(new Error("None of copying methods are supported by this browser!"));
        }
    });
}